/*
 * isa_sb16.h
 *
 *  Created on: 20-01-2012
 *      Author: Polprzewodnikowy
 */

#ifndef ISA_SB16_H_
#define ISA_SB16_H_

#define BASE_ADDR 0x240

#define IRQ5_GPIO	GPIOB
#define IRQ5_PIN	5

#define DRQ0_GPIO	GPIOB
#define DRQ0_PIN	1
#define DRQ5_GPIO	GPIOB
#define DRQ5_PIN	2

#define DACK0_GPIO	GPIOA
#define DACK0_PIN	11
#define DACK5_GPIO	GPIOA
#define DACK5_PIN	12

#define SET_DACK0	DACK0_GPIO->BSRR = (1<<DACK0_PIN)
#define CLR_DACK0	DACK0_GPIO->BRR = (1<<DACK0_PIN)
#define SET_DACK5	DACK5_GPIO->BSRR = (1<<DACK5_PIN)
#define CLR_DACK5	DACK5_GPIO->BRR = (1<<DACK5_PIN)

void SB_Init(void);
void SB_DSP_Reset(void);
void SB_DSP_SetTimeConst(uint32_t);
void SB_DSP_DMA_Config(uint8_t, uint8_t, uint32_t);
void SB_DSP_DMA_Close(uint8_t);
void SB_Mixer_Write(uint8_t, uint8_t);
uint8_t SB_Mixer_Read(uint8_t);
void SB_DSP_Write(uint16_t);
uint16_t SB_DSP_Read(void);

#endif /* ISA_SB16_H_ */
